#include <stdio.h>  
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <libharkio3.h>

#define ZIP_FILE_MAX  7



#define TF       17 //  transferFunction/ :  len[17] 
#define TF_READ  23 //  transferFunction/README"
#define TF_WHAT  31 //  transferFunction/whatisthis.txt :  len[31] 
#define TF_MIC   32 //  transferFunction/microphones.xml :  len[32] 
#define TF_SOUCE 27 //  transferFunction/source.xml :  len[27] 
#define TF_LOC   30 //  transferFunction/localization/ :  len[30] 
#define TF_SEP   28 //  transferFunction/separation/ :  len[28] 
#define LOC_MAT  41 //  transferFunction/localization/tf00000.mat :  len[41] 
#define SEP_MAT  39 //  transferFunction/separation/tf00001.mat :  len[39] 








void help(void)
{
	printf("                                                \n");
	printf("                                                \n");
	printf("[NAME:]                                         \n");
	printf("  harktoolcli-validtf                           \n");
	printf("                                                \n");
	printf("[Description:]                                  \n");
	printf("  Consistency check of the transfer function    \n");
	printf("                                                \n");
	printf("[Usage :]                                       \n");
    printf("  harktoolcli-validtf tf_filename(zip)          \n");
	printf("                                                \n");
}










int main(int argc, char **argv)
{

    int        errorp;
    int        index;
    const char *name;
    char msg[MSG_LEN];
    int  flags = 0;
    struct zip  *handle;
    zip_int64_t  num;
    memset(msg,  '\0' , sizeof(msg));
	int posCnt = 0;
	int posLocCheckCount =0;
	int posSepCheckCount =0;
	int zipCheckCount =0;
	int readme = 0;


	//check string
	char *checkDir[9] = { "transferFunction/"                 ,
						  "transferFunction/README"          , 
						  "transferFunction/whatisthis.txt"  ,
						  "transferFunction/microphones.xml" ,
						  "transferFunction/source.xml"      ,
                   		  "transferFunction/localization/"  ,
						  "transferFunction/separation/"     ,
                   		  "transferFunction/localization/tf" ,
						  "transferFunction/separation/tf" } ;






    // argc check
    if(argc == 1)
    {
		harkio_Log_printf(harkio_Log_Error , "argument error!!" );
        help();
		exit(EXIT_FAILURE);
    }




	//get position size
	harkio_TransferFunction *tf = NULL;

	tf = harkio_TransferFunction_fromFile( argv[1] , NULL);

	if(tf == NULL) 
	{
		harkio_Log_printf(harkio_Log_Error , "zip file error" );
		exit(EXIT_FAILURE);
	}

	posCnt = tf->poses->size ; 

	harkio_TransferFunction_delete(&tf);
	printf("\n\n"); 


	





    handle = zip_open( argv[1], ZIP_CHECKCONS, &errorp);

    if(handle == 0x00 )
    {
        sprintf(msg,"can not open zip file [%s]",argv[1]);
        harkio_Log_printf(harkio_Log_Error , msg);
        exit(EXIT_FAILURE);
    }

	//zip_int64_t zip_uint64_t zip_get_num_entries(struct zip *, int);
    num = zip_get_num_entries( handle ,  flags);

	//printf("zip num count : %d\n", (int)num);


	posLocCheckCount = 0;
	posSepCheckCount = 0 ;
	zipCheckCount = 0;
	readme =0;

	for( index=0 ; index< (int)num ; index++)
	{
		name = zip_get_name(handle,index,flags);

		if( strcmp( name  , checkDir[0] ) == 0 )
		{
			zipCheckCount++ ;
		}
		else if( strcmp( name  , checkDir[1] ) == 0)
		{
			zipCheckCount++ ;
			readme++ ;
		}
		else if( strcmp( name  , checkDir[2] ) == 0 )
		{
			zipCheckCount++ ;
		}
		else if( strcmp( name  , checkDir[3] ) == 0)
		{
			zipCheckCount++ ;
		}
		else if( strcmp( name  , checkDir[4] ) == 0) 
		{
			zipCheckCount++ ;
		}
		else if( strcmp( name  , checkDir[5]  ) == 0)  //"transferFunction/localization/" 
		{
			zipCheckCount++ ;
		}
		else if( strcmp( name  , checkDir[6] ) == 0 ) 
		{
			zipCheckCount++ ;
		}
		else if( strncmp( name  , checkDir[7] , strlen(checkDir[7]) ) == 0)  //"transferFunction/localization/tf" 
		{
			posLocCheckCount++ ;
		}
		else if( strncmp( name  , checkDir[8] , strlen(checkDir[8])) == 0 ) //transferFunction/separation/tf
		{
			posSepCheckCount++ ;
		}
		else
		{
			printf("[Unknown] %d : %s\n", index,name);
			sprintf(msg,"File format error [%s] zip cunt=%d",argv[1] , (int)num );
			harkio_Log_printf(harkio_Log_Error , msg);
			exit(EXIT_FAILURE);			
		}		
	}


	if( handle) 
	{
		zip_close( handle);
		handle = NULL;
	}


	if(readme == 0 ) zipCheckCount++;


	if( ( zipCheckCount == (int)ZIP_FILE_MAX ) && 
	    ( ( posLocCheckCount ==  0  &&  posSepCheckCount ==  posCnt )  ||
	      ( posSepCheckCount ==  0  &&  posLocCheckCount ==  posCnt )  || 
	      ( posSepCheckCount ==  posCnt && posLocCheckCount ==  posCnt )
        )
	  )
	{
		printf("SUCCESS\n");
	}
	else
	{
		sprintf(msg,"File format error [%s] zip cunt[%d] localization file[%d]  separation file[%d]  "
		          ,argv[1] 
		          , (int)num 
		          , posLocCheckCount 
		          ,posSepCheckCount   );

		harkio_Log_printf(harkio_Log_Error , msg);
	    exit(EXIT_FAILURE);
    } 
	

    exit(EXIT_SUCCESS);

}




